---
title: Maven
description: Maven Collector Plugin
---

import Plugin from '@site/src/components/Plugins';

Collects Maven artifacts.

<Plugin transferTag="hoppr.core_plugins.collect_maven_plugin">
{
`  maven_opts:
          - -Dhttp.proxyHost=proxy.mycompany.com
          - -Dhttp.proxyPort=80
          - -Dhttps.proxyHost=proxy.mycompany.com
          - -Dhttps.proxyPort=80
          - -Dhttp.nonProxyHosts=*.mycompany.com
`
}
</Plugin>

### Configuration Options

| Option          | Details                                                      |
| --------------- | -------------------------------------------------------------|
| maven_command   | String. Defaults to `mvn`. Command to be used to execute mvn commands. May be overridden with another command that uses the same syntax, or a fully qualified path if `mvn` is not on the default `$PATH`. |
| maven_opts      | Array of Strings. Additional options to be passed to the mvn command |
| process_timeout | Number of seconds to attempt collect before timeout. **Default:** 60 |

### Proxy and Certificate Configuration

To configure proxies, edit the `settings.xml` file for your Maven setup, as specified in [https://maven.apache.org/guides/mini/guide-proxies.html].

```xml
<settings>
    .
    .
    <proxies>
    <proxy>
        <id>example-proxy</id>
        <active>true</active>
        <protocol>http</protocol>
        <host>proxy.example.com</host>
        <port>8080</port>
        <username>proxyuser</username>
        <password>somepassword</password>
        <nonProxyHosts>www.google.com|*.example.com</nonProxyHosts>
    </proxy>
    </proxies>
    .
    .
</settings>
```

For configuring certificates for Maven, see: [https://maven.apache.org/guides/mini/guide-repository-ssl.html].

### Credentials Configuration

To specify credentials, you need a [credentials file](../../tutorials/processing-101.md#credentials).

Sample credentials file:

```yaml
---
schemaVersion: v1
kind: Credentials

metadata:
  name: Registry Credentials
  version: v1
  description: Sample credentials file

credential_required_services:
  - url: registry.gitlab.com
    user_env: CI_REGISTRY_USER
    pass_env: CI_REGISTRY_PASSWORD
```

### SBOM Generation Tools

- [cyclonedx-maven-plugin](https://github.com/CycloneDX/cyclonedx-maven-plugin) (plugin)

:::note
For more tools visit the [CycloneDX Tool Center](https://cyclonedx.org/tool-center/)
:::
